<template>
  <div
    :class="$options.style.classes"
    :style="{
      zIndex: zIndex
    }"
  >
    <component
      ref="modalVM"
      :is="modal.component"
      v-bind="{ ...modalProps }"
    />
  </div>
</template>

<script>
import Core from '@/Core'

/**
 * **ModalOverlay** component
 */
export default {
  name: 'ModalOverlay',
  props: {
    modal: {
      type: Object
    }
  },
  data () {
    return {}
  },
  computed: {
    modalProps: function () {
      return this.modal.props
    },
    /**
     * zIndex
     */
    zIndex: function () {
      return this.modal.props.layer === 'foreground'
        ? 9999
        : (Core.config.services['modal-manager'].baseZIndex + Number(this.modal.props.layer))
    }
  },
  methods: {},
  /**
   * 'style' custom option
   */
  style: {
    // Default classes
    classes: {
      '_modal-overlay': true
    }
  }
}
</script>

<style>
._modal-overlay {
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background-color: rgba(0, 0, 0, 0.2);
}
</style>
